% function [B,D]=BD_proj_ls_white_my_good2(Gammat,Gamma,Phi,UUU,SSS,VVV,Hs,W,k,delay);
%
% Estimates matrices B,D  using the projection approach.
% with orthonormalization
% Gamma  is the estimated observability matrix
%
% k : number of block rows
%
% UUU is the left factor in the svd of the inputs
% SSS is a vector containing the singular values
%
%  delay : is an 1 x m  row vector, delay(i) is set to 1 force  delay from the
%        i-th input; Dd(:,i) = 0.
%    default : delay = zeros(1,m); 



function [B,D]=BD_proj_ls_white_7_00_new(Ad,Cd,Gammat,Gamma,Phi,UUU,SSS,N,Hs,LAMBDAu,k,delay,joint);

%[U S V]=svd([Gammat]);

%Gammat = Gamma;
alt  =0;
[ru cu]=size(UUU);
m=round(ru/k);
if ((nargin > 13)| (nargin < 11))
   disp('Wrong number of input arguments');
   return 
end;

if (nargin < 13 | isempty(joint))
   joint = 0;
end;
if (nargin < 12 | isempty(delay)) 
   delay = zeros(1,m);
end;


% check dimensions of input matrices.
[rgt cgt] = size(Gammat);
[rg cg] = size(Gamma);
[rph cph] = size(Phi);

if joint
if cgt ~= cg, % compute deterministic part of the observability matrix 
  if alt 
      T = pinv(Gammat)*Gamma;
      Gamma = Gamma;
  else
   [U S V]=svd(Gammat*pinv(Gammat'*Gammat)*Gammat'*Gamma*pinv(Gamma'*Gamma)*Gamma');
   % compute change of basis
   %diag(S)
   [r c]=size(U(:,1:cg));
   AA = pinv(U(1:r-1,1:c))*U(2:r,1:c);
   %eig(AA)
   %keyboard 
   T = U(:,1:cgt)'*Gammat;
   Gamma = [U(:,1:cg) zeros(rg,cgt-cg)]*T;
end;
else
   T = eye(cg); 
end;
end;
%%%%%%%%%%%%%%%%%
Phi = Phi*(diag(SSS))*UUU';
%%%%%%%%%%%%%%%%%

[ru cu] = size(UUU);
rr = length(SSS);





if ((rg ~=rph) | (rgt ~=rph))
   disp('Gamma and Phi must have the same number of rows')
   return
end;


p = round(rg/k);   % numer of outputs
m = round(cph/k);  % number of inputs
if joint 
   if ~alt 
      n=cgt;
   end;
else 
   n = cg;     % state dimension
end;

   if length(delay) ~= m 
   disp('delay must have m entries')
   return
end;


Gperp = pinv(Hs); 
Hbar = Gperp*Phi;   
M = kron(Gperp*Gammat,eye(ru));

pp=rg; % number of rows of Gperp
ppp = n+p;

Gamma = Cd;
for i = 1: k-2;
   Gamma = [Cd ; Gamma*Ad];
end;

% construct the matrix K
K=[];
for i=0:k-2,
   K = [K Gperp(:,(i+1)*p+1:k*p)*Gamma(1:(k-1-i)*p,:) Gperp(:,i*p+1:(i+1)*p)];
end;
K= [K zeros(pp,n) Gperp(:,(k-1)*p+1:k*p)];



rr=length(SSS);
[rk ck] = size(K);

KK=zeros(rk*rr,(p+n)*m);
SSS = diag(SSS);

UUUT = UUU*SSS^2*UUU';

 for jj = 1:rk,
   
   for kk=1:k,
    KK((jj-1)*rr+1:jj*rr,:)=KK((jj-1)*rr+1:jj*rr,:)+kron(UUUT(m*(kk-1)+1:kk*m,:)',K(jj,(p+n)*(kk-1)+1:(p+n)*kk));
   end;
   %KK((jj-1)*rr+1:jj*rr,:)=SSS*KK((jj-1)*rr+1:jj*rr,:);
 end;
 
 
 Hbar =Hbar';
 ZZ = Hbar(:);
 
 
 Wbd = BD_white_7_00(k,N,m,p,LAMBDAu);
  
  
 
 
 %%%%%%%%%%%%%%%%%%%%%%%
 I = find(delay); % find inputs which have to be delayed
 
 if ~isempty(I)
    KK0=[];       
    prev=0;
    for i=1:length(I),
       t=I(i);
       KK0 = [KK0 KK(:,prev*(n+p)+1:(t-1)*(n+p)+n)];
       prev = t;
    end;
    if prev < m
     KK0 = [KK0 KK(:,prev*(n+p)+1:m*(n+p))];
    end
 
   
    KK =KK0;
    
     Ld = KK;
     LdbT= Ld'*Wbd;
     MbT = M'*Wbd;
     MM = MbT*M;
     Ldm = LdbT*M;
     invMM = inv(MM);
     BL = LdbT-Ldm*invMM*MbT;
     BLL = BL*Ld;
     BD = real(inv(BLL)*BL*ZZ);

    prev=0;
    D=zeros(p,m);
    for i=1:length(I),
       t=I(i);
       for j = prev+1:t-1,
         B(:,j)=BD((j-1)*n+(j-i)*p+1:(j-1)*n+(j-i)*p+n);
         D(:,j)=BD(j*n+(j-i)*p+1:j*n+(j-i+1)*p);
       end;
       B(:,t)=BD((t-1)*n+(t-i)*p+1:(t-1)*n+(t-i)*p+n);
       prev = t;
    end;
    if prev <m 
      for j = prev+1:m,
           B(:,j)=BD((j-1)*n+(j-i-1)*p+1:(j-1)*n+(j-i-1)*p+n);
           D(:,j)=BD(j*n+(j-i-1)*p+1:j*n+(j-i)*p); 
      end;
   end;
    
 else
    
   Ld = KK;
   LdbT= Ld'*Wbd;
   MbT = M'*Wbd;
   MM = MbT*M;
   Ldm = LdbT*M;
   invMM = inv(MM);
   BL = LdbT-Ldm*invMM*MbT;
   BLL = BL*Ld;

 %   KK = Wbd*KK;
 %   ZZ = Wbd*ZZ;
 %  svd(KK).^(-1)
 %   BD = KK\ZZ;
 BD = real(inv(BLL)*BL*ZZ);
 for t=1:m,
     B(:,t)=BD((t-1)*(n+p)+1:(t-1)*(n+p)+n);
     D(:,t)=BD((t-1)*(n+p)+n+1:t*(n+p));
    end;   
 end;
 
 if joint
   if alt 
       B = T*B;
    end;
 end;   


 
 
 
 
 
 












